#include "gradients565.h"


uint16_t g_red;
uint16_t g_green;
uint16_t g_blue;
float k_red;
float k_green;
float k_blue;
float NTSC;
float valp;
uint16_t gradient;

uint16_t grad_red_yellow_green(uint16_t val, uint16_t val_max, uint16_t val_ntsc)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	if(val_ntsc != 0)
	{
		if(valp < 50)
		{
			NTSC = 0.3 + 0.6 * valp / 50.0;
			k_red = 1.0 * NTSC;
			k_green = valp / 50.0 * NTSC;
			k_blue = 0;
		}
		if(valp >=50)
		{
			NTSC = 0.88 - 0.3 * ((valp - 50.0) / 50.0);
			k_red = (1.0 - ((valp - 50.0) / 50.0))* NTSC;
			k_green = 1.0 * NTSC;
			k_blue = 0;
		}
	}
	else
	{
		NTSC = 1;
		if(valp < 50)
		{
			k_red = 1.0 * NTSC;
			k_green = valp /50.0 * NTSC;
			k_blue = 0;
		}
		else if(valp >= 50)
		{
			k_red = (1.0 - ((valp - 50.0) / 50.0))* NTSC;
			k_green = 1.0 * NTSC;
			k_blue = 0;
		}
	}
	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = 0;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}

uint16_t grad_black_blue_green_red_white(uint16_t val, uint16_t val_max, uint16_t val_ntsc)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	if(val_ntsc != 0)
	{
		if(valp < 17.0)
		{
			NTSC    = 0.12 * valp / 17.0;
			k_red   = 0.0;
			k_green = 0.0;
			k_blue  = (1.0 * valp / 16.0) * NTSC;
		}
		else if(valp >= 17.0 && valp < 50.0)
		{
			NTSC    = 0.12 + 0.46 * (valp - 17.0)/33.0;
			k_red   = 0.0;
			k_green = (1.0 * (valp - 17) / 33.0) * NTSC;
			k_blue  = (1.0 - 1.0 * (valp - 17)/33.0) * NTSC;
		}
		else if(valp >= 50.0 && valp < 67.0)
		{
			NTSC    = 0.58 - 0.28 * (valp - 50.0) / 17.0;
			k_red   = 1.0 * (valp - 50) / 18.0 * NTSC;
			k_green = (1.0 - (valp - 50) / 18.0) * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 67.0)
		{
			NTSC    = 0.3 + 0.7 * (valp - 67.0) / 34.0;
			k_red   = 1.0 * NTSC;
			k_green = (1.0 * (valp - 67) / 33.0) * NTSC;
			k_blue  = (1.0 * (valp - 67) / 33.0) * NTSC;
		}
	}
	else
	{
		NTSC = 1.0;
		if(valp < 17.0)
		{
			k_red   = 0.0;
			k_green = 0.0;
			k_blue  = (1.0 * valp / 17.0) * NTSC;
		}
		else if(valp >= 17.0 && valp < 50.0)
		{
			k_red   = 0.0;
			k_green = (1.0 * (valp - 17) / 33.0) * NTSC;
			k_blue  = (1.0 - 1.0 * (valp - 17)/33.0) * NTSC;
		}
		else if(valp >= 50.0 && valp < 67.0)
		{
			k_red   = 1.0 * (valp - 50) / 18.0 * NTSC;
			k_green = (1.0 - (valp - 50) / 18.0) * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 67.0)
		{
			k_red   = 1.0 * NTSC;
			k_green = (1.0 * (valp - 67) / 33.0) * NTSC;
			k_blue  = (1.0 * (valp - 67) / 33.0) * NTSC;
		}
	}
	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}

uint16_t grad_rainbow(uint16_t val, uint16_t val_max, uint16_t val_ntsc)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	if(val_ntsc != 0)
	{
		if(valp < 17.0)
		{
			NTSC    = 0.3 + 0.57 * (valp / 17.0);
			k_red   = 1.0 * NTSC;
			k_green = 1.0 * (valp / 17.0) * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 17 && valp < 33 )
		{
			NTSC    = 0.87 - 0.29 * (valp - 17) / 17;
			k_red   = ( 1.0 -(valp - 17) / 17 ) * NTSC;
			k_green = 1.0 * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 33 && valp < 50)
		{
			NTSC    = 0.58 + 0.12 * (valp - 33) / 18;
			k_red   = 0.0;
			k_green = 1.0 * NTSC;
			k_blue  = (valp - 33) / 18 * NTSC;
		}
		else if(valp >= 50 && valp < 67)
		{
			NTSC    = 0.7 - 0.58 * (valp - 50) / 18;
			k_red   = 0.0;
			k_green = (1.0 - (valp - 50) / 18) * NTSC;
			k_blue  = 1.0 * NTSC;
		}
		else if(valp >= 67 && valp < 83)
		{
			NTSC    = 0.12 + 0.29 * (valp - 67) / 17;
			k_red   = (valp - 67) / 17 * NTSC;
			k_green = 0.0;
			k_blue  = 1.0 * NTSC;
		}
		else if(valp >= 83)
		{
			NTSC    = 0.41 - 0.11 * (valp - 83) / 18;
			k_red   = 1.0 *NTSC;
			k_green = 0.0;
			k_blue  = ( 1.0 - (valp - 83) / 18) * NTSC;
		}
	}
	else
	{
		NTSC = 1;
		if(valp < 17.0)
		{
			k_red   = 1.0 * NTSC;
			k_green = 1.0 * (valp / 17.0) * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 17 && valp < 33 )
		{
			k_red   = ( 1.0 -(valp - 17) / 17 ) * NTSC;
			k_green = 1.0 * NTSC;
			k_blue  = 0.0;
		}
		else if(valp >= 33 && valp < 50)
		{
			k_red   = 0.0;
			k_green = 1.0 * NTSC;
			k_blue  = (valp - 33) / 18 * NTSC;
		}
		else if(valp >= 50 && valp < 67)
		{
			k_red   = 0.0;
			k_green = (1.0 - (valp - 50) / 18) * NTSC;
			k_blue  = 1.0 * NTSC;
		}
		else if(valp >= 67 && valp < 83)
		{
			k_red   = (valp - 67) / 17 * NTSC;
			k_green = 0.0;
			k_blue  = 1.0 * NTSC;
		}
		else if(valp >= 83)
		{
			k_red   = 1.0 *NTSC;
			k_green = 0.0;
			k_blue  = ( 1.0 - (valp - 83) / 18) * NTSC;
		}
	}
	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}

uint16_t grad_white_gray_black(uint16_t val, uint16_t val_max)
{
	gradient = 0;
	valp = 100.0*((float)val_max-(float)val)/(float)val_max;
	NTSC    = valp/100;
	k_red   = valp/100 * NTSC;
	k_green = valp/100 * NTSC;
	k_blue  = valp/100 * NTSC;
	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}

uint16_t grad_lava(uint16_t val, uint16_t val_max)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	if(valp < 34 && valp >= 0)
	{
		k_red   = valp/34;
		k_green = 0.0;
		k_blue  = 0.0;
	}
	else if(valp >= 34 && valp < 68)
	{
		k_red   = 1.0;
		k_green = 1.0 * (valp - 34.0)/34.0;
		k_blue  = 0.0;
	}
	else if(valp >= 68 && valp <= 100)
	{
		k_red   = 1;
		k_green = 1;
		k_blue  = 1.0 * (valp - 67.0)/32.0;
	}

	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}

uint16_t grad_my_castom(uint16_t val, uint16_t val_max)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	valp /= 100;

	k_red   = sin((M_PI * 2) * valp);
	k_green = cos((M_PI * 2) * valp);
	k_blue  = sin((M_PI * 2 + M_PI) * valp);

	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}


uint16_t grad_black_purple_red_yellow(uint16_t val, uint16_t val_max)
{
	gradient = 0;
	valp = 100.0*(float)val/(float)val_max;
	valp /= 100;

	k_red   = sqrt(valp);
	k_green = pow(valp,3.0);
	k_blue  = sin(M_PI * 2 * valp);

	g_red = (uint16_t)((float)0x001f * k_red) & 0x001f;
	g_green = (uint16_t)((float)0x003f * k_green) & 0x003f;
	g_blue = (uint16_t)((float)0x001f * k_blue) & 0x001f;
	gradient = (g_red<<11) | (g_green<<5) | (g_blue);
	return gradient;
}
